<template>
  <q-page class="flex flex-center" style="background-color: #202020">
    <q-table
      title="USERS"
      style="width: 1000px; height: 550px"
      :rows="rows"
      :columns="columns"
      row-key="name"
      virtual-scroll
      :rows-per-page-options="[0]"
    >
      <template #body="props">
        <q-tr :props="props">
          <q-td key="id" :props="props"> {{ props.row.id }}</q-td>
          <q-td key="name" :props="props"> {{ props.row.name }}</q-td>
          <q-td key="username" :props="props"> {{ props.row.username }}</q-td>
          <q-td key="email" :props="props"> {{ props.row.email }}</q-td>
          <q-td key="address" :props="props"> {{ props.row.address }}</q-td>
          <q-td key="phone" :props="props"> {{ props.row.phone }}</q-td>
          <q-td key="website" :props="props"> {{ props.row.website }}</q-td>
          <q-td key="company" :props="props"> {{ props.row.company }}</q-td>
          <q-td key="action" :props="props">
            <q-btn
              flat
              icon="edit"
              dense
              @click="toggleEditDialog(props.row)"
            />
            <q-btn
              flat
              icon="delete"
              dense
              @click="toggleDeleteDialog(props.row)"
            />
          </q-td>
        </q-tr>
      </template>
    </q-table>
    <q-dialog v-model="showEditDialog" persistent>
      <q-card class="bg-dark">
        <q-form v-if="currentDialogForm === 1" class="q-ma-lg">
          <h6 class="text-center text-white q-ma-md">USER FORM</h6>
          <q-input
            class="q-mb-md"
            dark
            filled
            v-model="dialogData.name"
            label="Name"
            style="width: 300px"
            color="white"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <q-input
            class="q-mb-md"
            dark
            filled
            v-model="dialogData.username"
            label="Username"
            style="width: 300px"
            color="white"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <q-input
            class="q-mb-md"
            dark
            filled
            v-model="dialogData.email"
            label="Email"
            style="width: 300px"
            color="white"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <q-input
            class="q-mb-md"
            dark
            filled
            v-model="dialogData.phone"
            label="Phone #"
            style="width: 300px"
            color="white"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <q-input
            class="q-mb-md"
            dark
            filled
            v-model="dialogData.website"
            label="Website"
            style="width: 300px"
            color="dark"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <div class="text-right text-black q-ma-sm">
            <q-btn
              rounded
              label="Cancel"
              color="dark"
              style="margin-right: 20px"
              v-close-popup
            />
            <q-btn
              label="Next"
              color="dark"
              rounded
              style="width: 100px"
              push
              @click="currentDialogForm = 2"
            />
          </div>
        </q-form>
        <q-form v-if="currentDialogForm === 2" class="q-ma-lg">
          <h6 class="text-center text-white q-ma-md">COMPLETE ADDRESS</h6>

          <q-input
            dark
            filled
            v-model="dialogData.address.street"
            label="Street"
            style="width: 300px"
            color="white"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <q-input
            dark
            filled
            v-model="dialogData.address.suite"
            label="Suite"
            style="width: 300px"
            color="white"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <q-input
            dark
            filled
            v-model="dialogData.address.city"
            label="City"
            style="width: 300px"
            color="white"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <q-input
            dark
            filled
            v-model="dialogData.address.zipcode"
            label="Zip Code"
            style="width: 300px"
            color="white"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <q-input
            dark
            filled
            v-model="dialogData.address.geo.lat"
            label="Latitude"
            style="width: 300px"
            color="white"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <q-input
            dark
            filled
            v-model="dialogData.address.geo.lng"
            label="Longitude"
            style="width: 300px"
            color="white"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <div class="text-right">
            <q-btn
              label="Back"
              color="dark"
              rounded
              style="width: 100px; margin-right: 20px"
              push
              @click="currentDialogForm = 1"
            />
            <q-btn
              label="Next"
              color="dark"
              rounded
              style="width: 100px"
              push
              @click="currentDialogForm = 3"
            />
          </div>
        </q-form>
        <q-form v-if="currentDialogForm === 3" class="q-ma-lg">
          <h6 class="text-center text-white q-ma-md">COMPANY</h6>
          <q-input
            dark
            filled
            v-model="dialogData.company.name"
            label="Company Name"
            style="width: 300px"
            color="white"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <q-input
            dark
            filled
            v-model="dialogData.company.catchPhrase"
            label="Catch Phrase"
            style="width: 300px"
            color="white"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <q-input
            dark
            filled
            v-model="dialogData.company.bs"
            label="BS"
            style="width: 300px"
            color="white"
            hide-hint
            lazy-rule
            dense
            bottom-slots
          >
          </q-input>
          <div class="text-right">
            <q-btn
              rounded
              label="Back"
              color="dark"
              style="width: 100px; margin-right: 20px"
              push
              @click="currentDialogForm = 2"
            />
            <q-btn
              label="UPDATE"
              color="dark"
              rounded
              style="width: 100px"
              push
              @click="updateData()"
              v-close-popup
            />
          </div>
        </q-form>
      </q-card>
    </q-dialog>
    <q-dialog v-model="showDeleteDialog" persistent>
      <q-card>
        <q-card-section class="row items-center">
          <div class="q-ml-sm">Are you sure you want to delete?</div>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="CANCEL" color="white" v-close-popup />
          <q-btn
            label="YES"
            rounded
            color="white"
            @click="deleteData()"
            v-close-popup
          />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
import { ref } from "vue";
import {
  tableData,
  getUserData,
  updateData,
  deleteData,
} from "../composables/axios_data";

let selectedRow = ref({});
let rows = ref([]);
let currentDialogForm = ref(1);
let dialogData = ref({
  name: null,
  username: null,
  email: null,
  address: {
    street: null,
    suite: null,
    city: null,
    zipcode: null,
    geo: {
      lat: null,
      lng: null,
    },
  },
  phone: null,
  website: null,
  company: {
    name: null,
    catchPhrase: null,
    bs: null,
  },
});

export default {
  setup() {
    let showEditDialog = ref(false);
    let showDeleteDialog = ref(false);

    let columns = ref([
      {
        name: "id",
        label: "ID",
        align: "center",
        field: "id",
        sortable: true,
      },
      {
        name: "name",
        label: "NAME",
        align: "left",
        field: "name",
        sortable: true,
      },
      {
        name: "username",
        label: "USERNAME",
        align: "left",
        field: "username",
        sortable: true,
      },
      {
        name: "email",
        label: "EMAIL",
        align: "left",
        field: "email",
        sortable: true,
      },
      {
        name: "address",
        label: "ADDRESS",
        align: "left",
        field: "address",
        sortable: true,
      },
      {
        name: "phone",
        label: "PHONE No.",
        align: "left",
        field: "phone",
        sortable: true,
      },
      {
        name: "website",
        label: "WEBSITE",
        align: "left",
        field: "website",
        sortable: true,
      },
      {
        name: "company",
        label: "COMPANY",
        align: "left",
        field: "company",
        sortable: true,
      },
      {
        name: "action",
        label: "ACTION",
        align: "center",
        field: "action",
        sortable: true,
      },
    ]);

    let sliceAddress = (address) => {
      const parts = address
        .split(/[,()]/)
        .map((part) => part.trim())
        .filter((part) => part.length > 0);
      return parts;
    };

    const toggleEditDialog = (row) => {
      selectedRow.value = row;
      dialogData.value.name = row.name;
      dialogData.value.username = row.username;
      dialogData.value.email = row.email;
      dialogData.value.phone = row.phone;
      dialogData.value.website = row.website;

      let slicedAddress = sliceAddress(row.address);
      dialogData.value.address.street = slicedAddress[0];
      dialogData.value.address.suite = slicedAddress[1];
      dialogData.value.address.city = slicedAddress[2];
      dialogData.value.address.zipcode = slicedAddress[3];
      dialogData.value.address.geo.lat = row.latitude;
      dialogData.value.address.geo.lng = row.longitude;
      dialogData.value.company.name = row.company;
      dialogData.value.company.catchPhrase = row.catchPhrase;
      dialogData.value.company.bs = row.bs;
      showEditDialog.value = true;
    };

    const toggleDeleteDialog = (row) => {
      selectedRow.value = row;
      showDeleteDialog.value = true;
    };

    return {
      rows,
      columns,
      getUserData,
      tableData,
      showEditDialog,
      toggleEditDialog,
      dialogData,
      currentDialogForm,
      sliceAddress,
      updateData,
      toggleDeleteDialog,
      showDeleteDialog,
      deleteData,
    };
  },
};

export { rows, dialogData, selectedRow, currentDialogForm, deleteData };
</script>
